# Summary

* [Einleitung](README.md)
* [1 Einführung in Discovery-Systeme in Bibliotheken](01_0_Einfuehrung-Discovery-Systeme.md)
   * [1.1 OPAC vs. Discovery-System](01_1_opac_vs_discovery-system.md)
   * [1.2 Zwischenbilanz mit Problemen und Lösungsansätzen](01_2_zwischenbilanz_mit_problemen_und_loesungsansaetzen.md)
   * [1.3 Marktüberblick](01_3_marktueberblick.md)
* [2 Open-Source-Software für Bibliothekskataloge](02_0_Open-Source-Software_fuer_Bibliothekskataloge.md)
   * [2.1 Referat zu Pro & Contra von Open Source](02_1_referat_zu_pro_&_contra_von_open_source.md)
   * [2.2 Open Source Software zur Verarbeitung und Analyse von Metadaten](02_2_open_source_software_zur_verarbeitung_und_analyse_.md)
   * [2.3 Auswahl der Software für das Seminar](02_3_auswahl_der_software_fuer_das_seminar.md)
* [3 Grundinstallation der Arbeitsumgebung](03_0_grundinstallation_der_arbeitsumgebung.md)
   * [3.1 Installation der Systemumgebung](03_1_installation_der_systemumgebung.md)
   * [3.2 Einführung in die Linux Konsole](03_2_einfuehrung_in_die_linux_konsole.md)
   * [3.3 Verbinden mit dem Server über SSH](03_3_verbinden_mit_dem_server_ueber_ssh.md)
   * [3.4 Übung: Etwas über das System herausfinden](03_4_uebung_etwas_ueber_das_system_herausfinden.md)
   * [3.5 Übung: Text über die Konsole erstellen](03_5_uebung_text_ueber_die_konsole_erstellen.md)
   * [3.6 Übung: Text durchsuchen und Wörter zählen](03_6_uebung_text_durchsuchen_und_woerter_zaehlen.md)
* [4 Schnittstellen zum Laden der Metadaten](04_0_schnittstellen_zum_laden_der_metadaten.md)
   * [4.1 Schnittstellen des Bibliotheksverbunds GBV](04_1_schnittstellen_des_bibliotheksverbunds_gbv.md)
   * [4.2 Übung: unAPI-Schnittstelle des GBV](04_2_uebung_unapi-schnittstelle_des_gbv.md)
   * [4.3 Übung: Vergleich der verschiedenen Formate](04_3_uebung_vergleich_der_verschiedenen_formate.md)
   * [4.4 Download der Metadaten](04_4_download_der_metadaten.md)
* [5 Exkurs zu Metadaten in Bibliotheken](05_0_exkurs_zu_metadaten_in_bibliotheken.md)
   * [5.1 Einführung in Metadatenformate](05_1_einfuehrung_in_metadatenformate.md)
   * [5.2 Linked Data](05_2_linked_data.md)
   * [5.3 Initiativen zum Austausch von Metadaten](05_3_initiativen_zum_austausch_von_metadaten.md)
* [6 Installation von OpenRefine mit Docker](06_0_installation_von_openrefine_mit_docker.md)
   * [6.1 Installation Docker](06_1_installation_docker.md)
   * [6.2 Installation OpenRefine](06_2_installation_openrefine.md)
   * [6.3 OpenRefine starten und Daten laden](06_3_openrefine_starten_und_daten_laden.md)
   * [6.4 Zwischenfazit](06_4_zwischenfazit.md)
* [7 Datentransformation mit OpenRefine](07_0_datentransformation_mit_openrefine.md)
   * [7.1 Facetten und Text Filter](07_1_facetten_und_text_filter.md)
   * [7.2 Records bilden](07_2_records_bilden.md)
   * [7.3 Für jedes MARC-Feld eine Spalte](07_3_fuer_jedes_marc-feld_eine_spalte.md)
   * [7.4 Transformationen anwenden](07_4_transformationen_anwenden.md)
   * [7.5 Alle Daten in ein Projekt laden](07_5_alle_daten_in_ein_projekt_laden.md)
   * [7.6 Felder definieren](07_6_felder_definieren.md)
   * [7.7 Daten exportieren](07_7_daten_exportieren.md)
   * [7.8 Automatisierung](07_8_automatisierung.md)
* [8 Installation und Konfiguration des Suchmaschinenindex Solr](08_0_installation-und-konfiguration-des-suchmaschinenindex-solr.md)
   * [8.1 Installation von Solr mit Docker](08_1_installation-von-solr-mit-docker.md)
   * [8.2 Konfiguration des Solr Schemas](08_2_konfiguration-des-solr-schemas.md)
   * [8.3 TSV-Dateien in Solr laden](08_3_tsv-dateien-in-solr-laden.md)
* [9 Installation der Katalogoberfläche TYPO3-find](09_0_installation-der-katalogoberflaeche-typo3-find.md)
   * [9.1 Installation von TYPO3 mit Docker](09_1_installation-von-typo3-mit-docker.md)
   * [9.2 Erstkonfiguration von TYPO3](09_2_erstkonfiguration-von-typo3.md)
   * [9.3 Erweiterung TYPO3-find installieren](09_3_erweiterung-typo3-find-installieren.md)
   * [9.4 TYPO3-find anpassen](09_4_typo3-find-anpassen.md)
* [10 Exkurs zu Relevanzranking](10_0_exkurs-zu-relevanzranking.md)
   * [10.1 Referat zu Relevanzrankings](10_1_referat-zu-relevanzrankings.md)
   * [10.2 Relevanzranking mit TYPO3-find](10_2_relevanzranking-mit-typo3-find.md)
* [11 Projektpräsentationen und Abschlussdiskussion](11_0_projektpraesentationen-und-abschlussdiskussion.md)
   * [11.1 Projektpräsentationen](11_1_projektpraesentationen.md)
   * [11.2 Was haben wir im Seminar erreicht?](11_2_was-haben-wir-im-seminar-erreicht.md)
   * [11.3 Was fehlt noch für einen Produktivbetrieb?](11_3_was-fehlt-noch-fuer-einen-produktivbetrieb.md)
   * [11.4 Optimierung der virtuellen Maschine](11_4_optimierung-der-virtuellen-maschine.md)
* [Lerntagebücher](lerntagebucher.md)
* [Prüfungsleistungen](pruefungsleistungen.md)